Package: WWGbook
Version: 1.0.2
Date: 2022-02-28
Author: Shu Chen, Andrzej Galecki <agalecki@umich.edu>
Maintainer: Shu Chen <chenshu@umich.edu>
Title: Functions and Datasets for WWGbook
Description: Book is "Linear Mixed Models: A Practical Guide Using
        Statistical Software" published in 2006 by Chapman Hall / CRC
        Press.
Depends: R (>= 1.4.1)
License: GPL (>= 2)
URL: http://www-personal.umich.edu/~bwest/almmussp.html
LazyData: yes
NeedsCompilation: no
Packaged: 2022-03-01 22:04:46 UTC; eddyt
Repository: CRAN
Date/Publication: 2022-03-02 00:10:29 UTC
Built: R 4.4.0; ; 2024-05-08 13:31:48 UTC; unix

##############################################
#                                            #
#                 Chapter 6                  #
#                                            #
##############################################
library(WWGbook)
head(autism)
attach(autism)

sicdegp.f <- factor(sicdegp)
age.f <- factor(age)

# Add the new variables to a new data frame object.
autism.updated <- data.frame(autism, sicdegp.f, age.f)

###############################
#      Descriptive Analyses   #
###############################

# Number of Observations at each level of AGE
summary(age.f)
# Number of Observations at each level of AGE within each group
# defined by the SICDEGP factor
table(sicdegp.f, age.f)
# Overall summary for VSAE
summary(vsae)
# VSAE means at each AGE
tapply(vsae, age.f, mean, na.rm=TRUE)
# VSAE minimum values at each AGE
tapply(vsae, age.f, min, na.rm=TRUE)
# VSAE maximum values at each AGE
tapply(vsae, age.f, max, na.rm=TRUE)


#### Figure 6.1: Observed VSAE values plotted against age for children in each SICD group. 

library(lattice)  # Load the library for trellis graphics.
#trellis.device(color=F) # Make sure color is turned off.

# Load the nlme library, which is required for the 
# plots below as well as for subsequent models.
library(nlme)

autism.g1 <- groupedData(vsae ~ age | childid, 
outer = ~ sicdegp.f, data = autism.updated)

plot(autism.g1, display = "childid", outer = TRUE, aspect = 2, key = FALSE, xlab = "Age (Years)", ylab = "VSAE", 
main = "Individual Data by SICD Group") 

#### Figure 6.2: Mean Profiles of VSAE values for children in each SICD group. 

autism.g2 <- groupedData(vsae ~ age | sicdegp.f, 
order.groups = F, data = autism.updated)

plot(autism.g2, display = "sicdegp", aspect = 2, key = FALSE, 
xlab = "Age (Years)", ylab = "VSAE", 
main = "Mean Profiles by SICD Group")

###############################
#      Models Fitted          #
###############################

# Compute age.2 (AGE minus 2) and age.2sq (age.2 squared).
age.2 <- age - 2
age.2sq <- age.2*age.2

# Recode the SICDEGP factor for model fitting.
sicdegp2 <- sicdegp
sicdegp2[sicdegp == 3] <- 0
sicdegp2[sicdegp == 2] <- 2 
sicdegp2[sicdegp == 1] <- 1
sicdegp2.f <- factor(sicdegp2)

autism.updated <- subset(data.frame(autism, sicdegp2.f, age.2), !is.na(vsae))

library(nlme)

autism.grouped <- groupedData(vsae ~ age.2 | childid, data=autism.updated, order.groups = F)

model1.fit <- lme(vsae ~ age.2 + I(age.2^2) + sicdegp2.f +
age.2:sicdegp2.f + I(age.2^2):sicdegp2.f, 
random = ~ age.2 + I(age.2^2), method="REML", 
data = autism.grouped)
##Error: not converge

summary(model1.fit)

model2.fit <- lme(vsae ~ age.2 + I(age.2^2) + sicdegp2.f +
age.2:sicdegp2.f + I(age.2^2):sicdegp2.f, 
random = ~ age.2 + I(age.2^2) - 1, method="REML", 
data = autism.grouped)

summary(model2.fit)


model2a.fit <- update(model2.fit, random = ~ age.2 - 1)

h1.pvalue <- 0.5*(1-pchisq(83.9,1)) + 0.5*(1-pchisq(83.9,2))
h1.pvalue


model2.ml.fit <- update(model2.fit, method = "ML")

model3.ml.fit <- update(model2.ml.fit, 
fixed = ~ age.2 + I(age.2^2) + sicdegp2.f + age.2:sicdegp2.f)

anova(model2.ml.fit, model3.ml.fit)

model3.fit <- update(model2.fit, 
fixed = ~ age.2 + I(age.2^2) + sicdegp2.f + age.2:sicdegp2.f)

summary(model3.fit)

intervals(model3.fit)

getVarCov(model3.fit, individual="1", type="marginal")

############################
#  Model Diagnostics       #
############################

###Figure 6.4
curve(0.11*x^2 + 6.15*x + 13.46, 0, 11, xlab = "AGE minus 2", ylab = "Marginal Predicted VSAE", lty = 3, ylim=c(0,100), lwd = 2)

curve(0.11*x^2 + 2.65*x + 9.84, 0, 11, add=T, lty = 2, lwd = 2)

curve(0.11*x^2 + 2.08*x + 8.47, 0, 11, add=T, lty = 1, lwd = 2)

legend(locator(1),c("SICDEGP = 1", "SICDEGP = 2", 
"SICDEGP = 3"), lty = c(1,2,3), lwd = c(2,2,2))

###click the mouse button on the Figure 6.4 to put the legend on the place where you want


library(lattice)
trellis.device(color=F)

###Figure 6.5
plot(augPred(model3.fit, level = 0:1), layout=c(4,3,1),
xlab="AGE minus 2", ylab="Predicted VSAE",
key = list(lines = list(lty = c(1,2), col = c(1,1), 
lwd = c(1,1)), text = list(c("marginal mean profile",
"subject-specific profile")), columns = 2))

###Figure 6.6 
library(lattice)
trellis.device(color=F)
plot(model3.fit, resid(., type="p") ~ fitted(.) | factor(sicdegp), layout=c(3,1), aspect=2, abline=0)

plot(model3.fit, resid(., type="p") ~ fitted(.) | factor(sicdegp), id = 0.05, layout=c(3,1), aspect=2, abline=0)

###Figure 6.7 
plot(model3.fit, resid(.) ~ age.2, abline=0)

###Figure 6.8
qqnorm(model3.fit, ~resid(.) | factor(sicdegp), layout=c(3,1), aspect = 2, id = 0.05) 

detach(autism)

 

##############################################
#                                            #
#                 Chapter 7                  #
#                                            #
##############################################

 
library(WWGbook)

head(veneer)
attach(veneer)

age.f <- factor(age)
time.f <- factor(time)
tooth.f <- factor(tooth)

veneer <- data.frame(veneer,age.f, time.f, tooth.f)


###############################
#      Descriptive Analyses   #
###############################

sort(age.f)

#### Figure 7.2: Raw GCF values for each tooth vs. time, by patient. Panels are ordered by patient age.

library(lattice)  # Load the library for trellis graphics.
#trellis.device(color=F) # Make sure color is turned off.

# Load the nlme library, which is required for the 
# plots below as well as for subsequent models.
library(nlme)

veneer.g1 <- groupedData(gcf ~ time | tooth.f, 
outer = ~ age.f, data = veneer)
plot(veneer.g1, display = "tooth", outer = TRUE, aspect = 2, key = FALSE, xlab = "time", ylab = "GCF", main="age" ,
layout=c(4,3)) 

###############################
#      Model Analyses         #
###############################


library(nlme)

model7.1.fit <- lme(gcf ~ time + base.gcf + cda + age + time:base.gcf + time:cda + time:age, 
random = list(patient = ~ time, tooth = ~1), 
data = veneer, method = "REML")

summary(model7.1.fit)

intervals(model7.1.fit)

random.effects(model7.1.fit)

model7.1A.fit <- lme(gcf ~ time + base.gcf + cda + age + time:base.gcf + time:cda + time:age, 
random = list(patient = ~ time), data = veneer, method = "REML")

anova(model7.1.fit, model7.1A.fit)

model7.2A.fit <- lme(gcf ~ time + base.gcf + cda + age + time:base.gcf + time:cda + time:age, random = list(patient = ~ time, tooth = ~1), corr=corCompSymm(0.5, form=~1 | patient/tooth), weights = varIdent(form = ~1 | time), data = veneer, method = "REML")

summary(model7.2A.fit)

intervals(model7.2A.fit)

model7.2B.fit <- lme(gcf ~ time + base.gcf + cda + age + time:base.gcf + time:cda + time:age, random = list(patient = ~ time, tooth = ~1), corr=corCompSymm(0.5, form=~1 | patient/tooth), data = veneer, method = "REML")

summary(model7.2B.fit)

intervals(model7.2B.fit)
## Error in intervals.lme(model7.2B.fit)

model7.2C.fit <- lme(gcf ~ time + base.gcf + cda + age + time:base.gcf + time:cda + time:age, random = list(patient = ~ time, tooth = ~1), weights = varIdent(form = ~1 | time), data = veneer, method = "REML")

summary(model7.2C.fit)
intervals(model7.2C.fit)

anova(model7.2C.fit, model7.1.fit)

model7.1.ml.fit <- lme(gcf ~ time + base.gcf + cda + age + time:base.gcf + time:cda + time:age, 
random = list(patient = ~ time, tooth = ~1), data = veneer, method = "ML")

model7.3.ml.fit <- lme(gcf ~ time + base.gcf + cda + age, random = list(patient = ~ time, tooth = ~1), data = veneer, method = "ML")

anova(model7.1.ml.fit, model7.3.ml.fit)

model7.3.fit <- lme(gcf ~ time + base.gcf + cda + age, random = list(patient = ~ time, tooth = ~1), data = veneer, method = "REML")

summary(model7.3.fit)

############################
#  Diagnostics Analyses    #
############################

###Figure 7.4  
library(lattice)
trellis.device(color=F)
plot(model7.3.fit, resid(., type="p") ~ fitted(.),xlab="Predicted value", ylab="Residual",   abline=0)

###Figure 7.5
qqnorm(model7.3.fit, ~resid(.)) #layout=c(2,1), aspect = 2, id = 0.05) 

###Figure 7.6

qqnorm(model7.3.fit, ~ranef(.,level=1),layout=c(2,1), aspect = 2, id = 0.05) 


detach(veneer)

##############################################
#                                            #
#                 Chapter 3                  #
#                                            #
##############################################

 
library(WWGbook)

head(ratpup)

###############################
#      Descriptive Analyses   #
###############################

#Figure 3.1:Boxplots to compare the distributions of birth weights 
####for each treatment by sex combination graphically

library(lattice)  # trellis graphics
library(grid)

bwplot(weight ~ sex|treatment, data=ratpup,aspect = 2, ylab="Birth Weights", 
    xlab="SEX",main = "Boxplots of birth weights for levels of treatment by sex")

#Figure 3.2:Boxplots to illustrate the relationship between birth weight and litter size. 
####Each panel shows the distributions of birth weights
####for all litters ranked by size, within a given level of treatment and sex. 

attach(ratpup)
ranklit <- litsize+0.01*litter
sort(ranklit)
ranklit
ranklit <- factor(ranklit)

levels(ranklit) <- as.character(1:27)
ranklit
bwplot(weight ~ranklit | treatment*sex, data=ratpup,aspect = 2, ylab="Birth Weights", 
    xlab="" )

###recode the variable SEX into SEX1
ratpup$sex1[sex == "Female"] <- 1
ratpup$sex1[sex == "Male"] <- 0

 
#########################################
#      Models Fitted by using lme       #
#########################################

library(nlme)

# Model 3.1.
model1.fit <- lme(weight ~ treatment + sex1 + litsize + treatment*sex1, 
    random = ~1 | litter, ratpup, method = "REML")
summary(model1.fit)
anova(model1.fit)

# Display the random effects (EBLUPs) from the model.
random.effects(model1.fit)

# Model 3.1A.
model1a.fit <- gls(weight ~ treatment + sex1 + litsize + treatment*sex1, data = ratpup)
anova(model1.fit, model1a.fit)  #Test Hypothesis 1.

# Model 3.2A.
model2a.fit <- lme(weight ~ treatment + sex1 + litsize + treatment*sex1, random = ~1 | litter, ratpup, method = "REML", weights = varIdent(form = ~1 | treatment))

# Test Hypothesis 3.2.
anova(model1.fit, model2a.fit)

ratpup$trtgrp[treatment == "Control"] <- 1
ratpup$trtgrp[treatment == "Low" | treatment == "High"] <- 2

model2b.fit <- lme(weight ~ treatment + sex1 + litsize + treatment*sex1, random = ~1 | litter, ratpup, method = "REML", weights = varIdent(form = ~1 | trtgrp))

# Test Hypothesis 3.3.
anova(model2a.fit, model2b.fit) 

# Test Hypothesis 3.4.
anova(model1.fit, model2b.fit) 

summary(model2b.fit) 

# Test Hypothesis 3.5.
anova(model2b.fit)  

model3.ml.fit <- lme(weight ~ treatment + sex1 + litsize, random = ~1 | litter, ratpup, method = "ML", weights = varIdent(form = ~1 | trtgrp))
model3a.ml.fit <- lme(weight ~ sex1 + litsize, random = ~1 | litter, ratpup, method = "ML", weights = varIdent(form = ~1 | trtgrp))

# Test Hypothesis 3.6.
anova(model3.ml.fit, model3a.ml.fit)

# Model 3.3: Final Model.
model3.reml.fit <- lme(weight ~ sex1 + litsize + treatment, random = ~1 | litter, ratpup, method = "REML", 
weights = varIdent(form = ~1 | trtgrp))
summary(model3.reml.fit)
anova(model3.reml.fit)


intervals(model3.reml.fit)

getVarCov(model3.reml.fit, individual="1", type="marginal")


############################
#  Model Diagnostics       #
############################


library(lattice)
trellis.device(color=F)

###Figure 3.4
res <- resid(model3.reml.fit)
ratred <- data.frame(ratpup, res)
ratred
histogram( ~res | factor(trtgrp),data=ratred, layout=c(2,1), aspect = 2 , xlab = "Residual") 

###Figure 3.5
qqnorm(model3.reml.fit, ~resid(.) | factor(trtgrp), layout=c(2,1), aspect = 2, id = 0.05) 

###Figure  3.6 
plot(model3.reml.fit, resid(., type="p") ~ fitted(.) | factor(trtgrp), layout=c(2,1), aspect=2, abline=0)

###Figure 3.7
bwplot(resid(model3.reml.fit) ~ranklit, data=model3.reml.fit, ylab="residual", xlab="litter")

detach(ratpup)

##########################################
#      Models Fitted by using lmer       #
##########################################

library(WWGbook)

library(Matrix)
 library(lme4) 
attach(ratpup)
ratpup$sex2[sex == "Female"] <- 1 
ratpup$sex2[sex == "Male"] <- 0 
# Model 3.1. 
model3.1.fit <- lmer(weight ~ treatment + sex2 + litsize + treatment*sex2 + (1 | litter), ratpup, method = "REML") 
summary(model3.1.fit) 
anova(model3.1.fit) 
ranef(model3.1.fit)$litter 

detach(ratpup)

##############################################
#                                            #
#                 Chapter 5                  #
#                                            #
##############################################
library(WWGbook)
head(rat.brain)
attach(rat.brain)

###############################
#      Descriptive Analyses   #
###############################

region.f <- region
region.f[region == 1] <- 1
region.f[region == 2] <- 2
region.f[region == 3] <- 0
region.f <- factor(region.f)
treat <- treatment
treat[treatment == 1] <- 0
treat[treatment == 2] <- 1
treat <- factor(treat)
rat.brain <- data.frame(rat.brain, region.f, treat)

#######table report on page 221######

###overall ###
dim(rat.brain)  #obs
summary(rat.brain$activate) #mean
sqrt(var(rat.brain$activate)) #stdev

###by treatment group###
summary(treat)     #obs
by(rat.brain$activate,list(treat),summary) #mean
sqrt(by(rat.brain$activate,list(treat),var))   #stdev

###by region group###
summary(region.f) #obs
by(rat.brain$activate,list(region.f),summary) #mean
sqrt(by(rat.brain$activate,list(region.f),var))   #stdev

###by treat and region group###
table(treat,region.f)  #obs
by(rat.brain$activate,list(treat, region.f),summary)  #mean
sqrt(by(rat.brain$activate,list(treat, region.f),var)) #stdev

###Figure 5.1: Line graphs of activation for each animal by region within levels of treatment for the Rat Brain data.

library(lattice)  # Load the library for trellis graphics.
#trellis.device(color=F) # Make sure color is turned off.

# Load the nlme library, which is required for the 
# plots below as well as for subsequent models.
library(nlme)

rat.brain.g1 <- groupedData(activate ~ region | animal, 
outer = ~ treat, data = rat.brain)

plot(rat.brain.g1, display = "animal", outer = TRUE, aspect = 2, key = FALSE, xlab = "region", ylab = "mean activate", main="treatment" ) 

 
###############################
#      Models Fitted          #
###############################
 

# Model 5.1.
model5.1.fit <- lme(activate ~ region.f*treat, 
random = ~1 | animal, method = "REML", data = rat.brain)

summary(model5.1.fit)
anova(model5.1.fit)

# Model 5.2.
model5.2.fit <- update(model5.1.fit, random = ~treat | animal)

summary(model5.2.fit)
anova(model5.2.fit)

0.5*(1 - pchisq(26.1,1)) + 0.5*(1 - pchisq(26.1,2))


# Model 5.3.
model5.3.fit <- lme(activate ~ region.f*treat, 
random = ~treat | animal, 
weights = varIdent(form = ~1 | treat), 
data = rat.brain)

summary(model5.3.fit)

# Likelihood ratio test for Hypothesis 5.2.
anova(model5.2.fit, model5.3.fit)

getVarCov(model5.2.fit, individual = "R100797", type = "marginal")

############################
#  Model Diagnostics       #
############################

###Figure 5.3
qqnorm(model5.2.fit, ~resid(.)) #layout=c(2,1), aspect = 2, id = 0.05) 

###Figure 5.4  
fit <- predict(model5.2.fit)
res <- resid(model5.2.fit)
plotres.fit <-data.frame(rat.brain, fit, res)
xyplot(res~fit,data=plotres.fit,groups=treatment, xlab="Predicted value", ylab="Residual",abline=0)


detach(rat.brain)

##############################################
#                                            #
#                 Chapter 4                  #
#                                            #
##############################################

 
library(WWGbook)

head(classroom)

attach(classroom)


###############################
#      Descriptive Analyses   #
###############################


 
#### Descriptive Summary #1

# Level 1 Descriptive Statistics

 
level1 <- data.frame(sex,minority,mathkind,mathgain,ses)
summary(level1)
dim(level1)

# Level 2 Descriptive Statistics

level2 <- aggregate(classroom,list(classid = classroom$classid),mean)
summary(level2$yearstea)
dim(level2)

# Level 3 Descriptive Statistics

level3 <- aggregate(classroom,list(schoolid = classroom$schoolid),mean)
summary(level3$housepov)
dim(level3)


###############################
#      Descriptive Analyses   #
###############################


 
#### Descriptive Summary #1

# Level 1 Descriptive Statistics

 
level1 <- data.frame(sex,minority,mathkind,mathgain,ses)
summary(level1)
dim(level1)

# Level 2 Descriptive Statistics

level2 <- aggregate(classroom,list(classid = classroom$classid),mean)
summary(level2$yearstea)
dim(level2)

# Level 3 Descriptive Statistics

level3 <- aggregate(classroom,list(schoolid = classroom$schoolid),mean)
summary(level3$housepov)
dim(level3)

 
#### Descriptive Summary #2
 
classroom.nomiss <- subset(classroom, !is.na(mathknow))

# Level 1 Descriptive Statistics

level1 <- data.frame(classroom.nomiss$sex,classroom.nomiss$minority,classroom.nomiss$mathkind,classroom.nomiss$mathgain,classroom.nomiss$ses)
summary(level1)
dim(level1)

# Level 2 Descriptive Statistics

level2.agg <- aggregate(classroom.nomiss,list(classid = classroom.nomiss$classid),mean)
level2 <- data.frame(level2.agg$yearstea,level2.agg$mathknow,level2.agg$mathprep)
summary(level2)
dim(level2)

# Level 3 Descriptive Statistics

level3.agg <- aggregate(classroom.nomiss,list(schoolid = classroom.nomiss$schoolid),mean)
summary(level3.agg$housepov)
dim(level3.agg)

 
#### Boxplots for Figure 4.2. 
 
classroom.first8 <- classroom[classroom$schoolid <= 8,]
par(mfrow=c(4,2))
for (i in 1:8) 
{boxplot(classroom.first8$mathgain[classroom.first8$schoolid==i] ~ classroom.first8$classid[classroom.first8$schoolid==i],ylab="Mathgain", xlab="Classid" )}

###############################
#      Models Fitted          #
###############################

library(nlme)

# Model 4.1.
model4.1.fit <- lme(mathgain ~ 1, random = ~1 | schoolid/classid, classroom, method = "REML")
summary(model4.1.fit)
random.effects(model4.1.fit)

# Model 4.1A.
model4.1A.fit <- lme(mathgain ~ 1, random = ~1 | schoolid, classroom, method = "REML")
anova(model4.1.fit, model4.1A.fit)

# Model 4.2.
model4.2.fit <- lme(mathgain ~ mathkind + sex + minority + ses, random = ~1 | schoolid/classid, classroom, 
   na.action = "na.omit", method = "REML")
summary(model4.2.fit)
ranef(model4.2.fit)

# Model 4.1: ML estimation.
model4.1.ml.fit <- lme(mathgain ~ 1, 
random = ~1 | schoolid/classid, classroom, method = "ML")

# Model 4.2: ML estimation.
model4.2.ml.fit <- lme(mathgain ~ mathkind + sex + minority + ses, random = ~1 | schoolid/classid, classroom, 
na.action = "na.omit", method = "ML")

anova(model4.1.ml.fit, model4.2.ml.fit)

# Model 4.3.
model4.3.fit <- update(model4.2.fit, 
fixed = ~ mathkind + sex + minority + ses + yearstea + mathprep + mathknow)

summary(model4.3.fit)

# Model 4.4.
model4.4.fit <- update(model4.2.fit, 
fixed = ~ mathkind + sex + minority + ses + housepov)

summary(model4.4.fit)


intervals(model4.4.fit)

###getVarCov(model4.4.fit, individual="1", type="marginal")

############################
#  Model Diagnostics       #
############################

library(lattice)
trellis.device(color=F)

#### Figure 4.4
#pred <- predict(model4.2.fit)
#classroom.1 <- data.frame(classroom,pred)
#postscript(name="threshold_all.jpf",onfile=F, print.it=F)
x <- mathkind
y <- mathgain
classroom.1<-data.frame(classroom,x,y)
fig.4panel <- function(x,y,subscripts,groups) {
                panel.superpose(x,y,subscripts,groups)
                for(g in as.character(unique(groups[subscripts]))) {
                        sub <- groups[subscripts] == g
                        fit <- lm(y~x,subset=sub)
                        ord <- order(x[sub])
                        lines(x[sub][ord],fitted(fit)[ord]) 
                }
        }

xyplot(y ~ x, groups=minority,data=classroom.1) #panel=fig.4panel)


#### Figure 4.5
qqnorm(model4.2.fit, ~ranef(.,level=2))

###Figure 4.6
qqnorm(model4.2.fit, ~ranef(.,level=1))

#### Figure 4.7
qqnorm(model4.2.fit, ~resid(.),plot.it = TRUE ) 
 

#### Figure 4.8 
plot(model4.2.fit, resid(., type="p") ~ fitted(.), abline=0)


detach(classroom) 

 
